function delta_error_Temp=Costfcn(x,optim_type)

    global t_sim Sigma_SB R_Ex_Gas cp_Ex_Gas T_amb  C_s cp_SCR p_amb  Ea_fastSCR k_fastSCR  SCR_D Epsilon_Rad m_SCR k_ads  NH3_Slip_Optim
    global Epsilon  k_des  mdot_exgas ndot_NH3 T_exgas Init_SCR_Temp M_NH3 n_Cell R A_rad A_SCR L_SCR V_SCR NO_Slip_Optim NO2_Slip_Optim  n_Cell_T
    global alpha dh_NH3  Ea_oxN2 k_oxN2 NOX_Slip_Optim ndot_no ndot_no2 Ea_stdSCR k_stdSCR k_slowSCR Ea_slowSCR Temp_Optim K2 K1  A1 A2 A3  h_radiation
    global  A_Pipe m_total c_pipe h_pipe Init_pipe_temp mflow_urea zeta_us cp_h2Og cp_urea cp_h20l rv_h20   h_external  h_internal h_convection Epsilon_pipe D_inner  L_pipe

    % Comment out parameters that are not being estimated and set them to
    % zero in the main cose SCR_Param. Re-order the indices of x depending
    % on parameters being estimated. 
    
switch optim_type
    case 'TPD'
        k_des=x(1);
        dh_NH3=x(2);
        k_ads=x(3);
        C_s=x(4);
        alpha=x(5);
    case 'StandardSCR'
        k_stdSCR =x(1);
        Ea_stdSCR =x(2);
    case 'SlowSCR'
        k_slowSCR=x(1);
        Ea_slowSCR=x(2);
    case 'FastSCR'
        k_fastSCR = x(1);
        Ea_fastSCR=x(2);
    case 'NH3Oxidation'
        k_oxN2=x(1);
        Ea_oxN2=x(2);
end

set_param('Threecell_SCR_Integrator_9celltemp','SimulationMode','accelerator','MaxConsecutiveZCsMsg','none');
Options=simset('SrcWorkspace','current','Solver','ode15s','OutputPoints','specified');

% Change time in the sim command to 0:0.5:t_sim(end) when running for WHTC.


% Use this cost function for TPD only 

switch optim_type
    case 'TPD'
        sim('Threecell_SCR_Integrator_9celltemp.slx',[1:t_sim(end)],Options);
        delta_error_Temp=sum((NH3_ppm_int-NH3_Slip_Optim).^2);
    case 'StandardSCR'
        sim('Threecell_SCR_Integrator_9celltemp.slx',[0:t_sim(end)],Options);
        delta_error_Temp=sum((NH3_ppm_int-NH3_Slip_Optim).^2/var(NH3_ppm_int-NH3_Slip_Optim)+(NO_ppm_int-NO_Slip_Optim).^2/var(NO_ppm_int-NO_Slip_Optim));
    case 'SlowSCR'
        sim('Threecell_SCR_Integrator_9celltemp.slx',[0:t_sim(end)],Options);
        delta_error_Temp=sum((NH3_ppm_int-NH3_Slip_Optim).^2/var(NH3_ppm_int-NH3_Slip_Optim)+(NO2_ppm_int-NO2_Slip_Optim).^2/var(NO2_ppm_int-NO2_Slip_Optim));
    case {'FastSCR','NH3Oxidation'}
        sim('Threecell_SCR_Integrator_9celltemp.slx',[0:t_sim(end)],Options);
        delta_error_Temp=sum((NH3_ppm_int-NH3_Slip_Optim).^2/var(NH3_ppm_int-NH3_Slip_Optim)+(NO_ppm_int-NO_Slip_Optim).^2/var(NO_ppm_int-NO_Slip_Optim)+(NO2_ppm_int-NO2_Slip_Optim).^2/var(NO2_ppm_int-NO2_Slip_Optim));
end

% READ BEFORE RUNNING:

% Use for standard SCR, slow SCR and fast SCR. Delete the portion of the
% cost function which is not present in the feed. For ex: If carrying out
% the estimation for standard SCR, delete the portion with NO2 as it is not
% present in the input feed. Otherwise the value of the cost function will
% go to infinity. 

% delta_error_Temp=sum((NH3_ppm_int-NH3_Slip_Optim).^2/var(NH3_ppm_int-NH3_Slip_Optim)+(NO_ppm_int-NO_Slip_Optim).^2/var(NO_ppm_int-NO_Slip_Optim)+(NO2_ppm_int-NO2_Slip_Optim).^2/var(NO2_ppm_int-NO2_Slip_Optim));
end